%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                     %
%            PROOF OF SECURITY PROPERTIES             %
%                                                     %
%  :- checkAllProp.                                   %
%                                                     %
% Property 1 (including 15 lemmas)                    %
% Property 2: can't currently be proved with {log}    %
% Property 3                                          %
% Property 4                                          %
% Property 5: not formally specified by Altran Praxis %
% Property 6                                          %
%                                                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%% 19 proof obligations

%%%%% 308 seconds (1 (1-15), 3, 4, 6)
%%%%% 158 seconds concurrent (1 (1-15), 3, 4, 6)

tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) :-
  tisUpdate(IDStation__,RealWorld__,RealWorld_,IDStation_) &
  tisProcessing(M,IDStation,RealWorld,RealWorld__,IDStation__).

% Status_ = gotUserToken ==> (Status_ neq Status ==> Status = quiescent)
property1_01 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status neq quiescent & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status neq Status_ & Status_ = gotUserToken.

% Status_ = {waitingRemoveTokenSuccess, waitingEntry, waitingFinger} 
%   ==> (Status_ neq Status ==> Status = gotUserToken)
property1_02 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status neq gotUserToken & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ neq Status & 
  Status_ = {waitingRemoveTokenSuccess, waitingEntry, waitingFinger}.

% Status_ = gotFinger
%   ==> (Status_ neq Status ==> Status = waitingFinger)
property1_03 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status neq waitingFinger &
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ neq Status & Status_ = gotFinger.

% Status_ = waitingUpdateToken 
%   ==> (Status_ neq Status ==> Status = gotFinger)
property1_04 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status neq gotFinger &
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ neq Status & Status_ = waitingUpdateToken.

% Status_ = waitingEntry 
%   ==> (Status_ neq Status ==> Status in {waitingUpdateToken,gotUserToken})
property1_05 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status nin {waitingUpdateToken, gotUserToken} & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ neq Status & Status_ = waitingEntry.

% Status_ = waitingRemoveTokenSuccess  
%   ==> (Status_ neq Status ==> Status = waitingEntry)
property1_06 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status neq waitingEntry & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ neq Status & Status_ = waitingRemoveTokenSuccess.

% Status = gotUserToken
%   ==> (Status_ = waitingFinger 
%          ==> validToken(CurrentUserToken_) &
%              userTokenOK(KeyStore_,UserToken_,CurrentTime_,CurrentTime_))
% Had to add EnclaveStatus = enclaveQuiescent as hypothesis because
% tisShutdownOp can go from gotUserToken to waitingFinger without
% checking the token
property1_07 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,_DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status = gotUserToken & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [UserToken_,_AdminToken_,_Finger_,DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    UserToken_ = [CurrentUserToken_,_] &
    DoorLatchAlarm_ = [CurrentTime_,_,_CurrentLatch,_,_,_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ = waitingFinger &
  (CurrentUserToken_ in {noT, badT}
   or
   CurrentUserToken_ = goodT(Token_) &
   not_validToken(Token_) 
   or
   KeyStore_ = [IssuerKey_,_] &
   pfun(IssuerKey_) &   % state invariant
   not_userTokenOKNoCurrencyCheck(KeyStore_,UserToken_,CurrentTime_,CurrentTime_)
  ).

% Status = gotFinger
%   ==> (Status_ = waitingUpdateToken ==> fingerOK(Finger_,UserToken_))
% Had to add EnclaveStatus = enclaveQuiescent as hypothesis because
% tisShutdownOp can go from gotFinger to waitingUpdateToken without
% checking the finger
property1_08 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,_DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status = gotFinger & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [UserToken_,_AdminToken_,Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ = waitingUpdateToken &
  not_fingerOK(Finger_,UserToken_).

% Status = gotUserToken
%   ==> (Status_ = waitingEntry 
%          ==> tokenWithValidAuth(UserToken) &
%              userTokenWithOKAuthCert(KeyStore_,UserToken_,CurrentTime_))
% Had to add EnclaveStatus = enclaveQuiescent as hypothesis because
% tisShutdownOp can go from gotUserToken to waitingEntry without
% checking the token.
% That is, in the next state (1) holds
property1_09 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,_DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status = gotUserToken & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    UserToken_ = [CurrentUserToken_,_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ = waitingEntry &
  (not_tokenWithValidAuth(CurrentUserToken_)
   or
   KeyStore_ = [IssuerKey_,_] &
   pfun(IssuerKey_) &   % state invariant
   not_userTokenWithOKAuthCertNoCurrencyCheck(KeyStore_,UserToken_,_)
  ).

% Status = waitingRemoveTokenSuccess
%   ==> (Status_ neq Status ==> Status_ = quiescent)
property1_10 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status = waitingRemoveTokenSuccess & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ neq Status & 
  Status_ nin {waitingRemoveTokenFail, quiescent}.

% Status = waitingRemoveTokenFail
%   ==> (Status_ neq Status ==> Status_ = quiescent)
property1_11 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,_Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Internal = [Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus neq waitingStartAdminOp &
  Status = waitingRemoveTokenFail & 
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [Status_,_EnclaveStatus,_TokenRemovalTimeout] &
  Status_ neq Status & 
  Status_ neq quiescent.

% EnclaveStatus = enclaveQuiescent & RolePresent = nil 
%   ==> (Status_ neq Status ==> EnclaveStatus_ = gotAdminToken)
property1_12 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Admin = [RolePresent,_,_] &
    Internal = [_Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus = enclaveQuiescent &
  RolePresent = {} &
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,_Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Internal_ = [_Status_,EnclaveStatus_,_TokenRemovalTimeout] &
  EnclaveStatus_ neq EnclaveStatus & 
  EnclaveStatus_ neq gotAdminToken.

% EnclaveStatus = gotAdminToken & RolePresent = nil 
%   ==> (Status_ neq Status 
%          ==> EnclaveStatus_ = enclaveQuiescent & RolePresent_ neq {})
property1_13 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Admin = [RolePresent,_,_] &
    Internal = [_Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus = gotAdminToken &
  RolePresent = {} &
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Admin_ = [RolePresent_,_,_] &
    Internal_ = [_Status_,EnclaveStatus_,_TokenRemovalTimeout] &
  EnclaveStatus_ neq EnclaveStatus & 
  (EnclaveStatus_ neq enclaveQuiescent or RolePresent_ = {}).

% EnclaveStatus = enclaveQuiescent & RolePresent neq nil 
%   ==> (Status_ neq Status ==> EnclaveStatus_ = waitingStartAdminOp)
property1_14 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Admin = [RolePresent,_,_] &
    Internal = [_Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus = enclaveQuiescent &
  RolePresent neq {} &
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,_AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    Admin_ = [RolePresent_,_,_] &
    Internal_ = [_Status_,EnclaveStatus_,_TokenRemovalTimeout] &
  EnclaveStatus_ neq EnclaveStatus & 
  EnclaveStatus_ neq waitingStartAdminOp.

% EnclaveStatus = gotAdminToken & RolePresent = nil 
%   ==> (Status_ neq Status 
%          ==> EnclaveStatus_ = enclaveQuiescent &
%              the(RolePresent_,AuthCertRole) &
%              validToke(AdminToken))
% That is, in the next state (2) holds
property1_15 :-
  IDStation = 
    [_UserToken,_AdminToken,_Finger,DoorLatchAlarm,_Floppy,
     _Keyboard,_Config,_Stats,_KeyStore,Admin,_AuditLog,Internal,
     _CurrentDisplay,_CurrentScreen] &
    Admin = [RolePresent,_,_] &
    Internal = [_Status,EnclaveStatus,_TokenRemovalTimeout] &
  EnclaveStatus = gotAdminToken &
  RolePresent = {} &
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
  IDStation_ = 
    [_UserToken_,AdminToken_,_Finger_,_DoorLatchAlarm_,_Floppy_,
     _Keyboard_,_Config_,_Stats_,_KeyStore_,Admin_,_AuditLog_,Internal_,
     _CurrentDisplay_,_CurrentScreen_] &
    AdminToken_ = [CurrentAdminToken_,_] &
    CurrentAdminToken_ = [_TokenID,_IDCert,_PrivCert,_IandACert,AuthCert_] &
    AuthCert_ = [_Id,_ValidityPeriod,_IsValidatedBy,_BaseCertId,_TokenID,
      Role_,_Clearance] &
    Admin_ = [RolePresent_,_,_] &
    Internal_ = [_Status_,EnclaveStatus_,_TokenRemovalTimeout] &
  EnclaveStatus_ = enclaveQuiescent &
  (the(RolePresent_,R) & R neq Role_
   or
   not_validToken(CurrentAdminToken_)
  ).

tisUserEntryOp_1(IDStation,RealWorld,RealWorld_,IDStation_) :-
  tisReadUserToken(IDStation,RealWorld,RealWorld_,IDStation_) 
  or
  tisValidateUserToken(IDStation,RealWorld,RealWorld_,IDStation_) 
  or
  tisReadFinger(IDStation,RealWorld,RealWorld_,IDStation_) 
  or
  tisValidateFinger(IDStation,RealWorld,RealWorld_,IDStation_)
  or
  tisWriteUserToken(IDStation,RealWorld,RealWorld_,IDStation_) 
  or
  tisValidateEntry(IDStation,RealWorld,RealWorld_,IDStation_) 
  or
    IDStation = [UserToken,_,Finger,_,_,_,_,_,KeyStore,_,_,_,_,_] &
      UserToken = [CurrentUserToken,_] &
      Finger = [CurrentFinger,_] &
      KeyStore = [IssuerKey,OwnName] &
    RealWorld = [TISControlledRealWorld,TISMonitoredRealWorld] &
      TISMonitoredRealWorld = [Now,_,_,_,_,_,_] &

    CurrentFinger = goodFP(_) &      %%%% (1)

    CurrentUserToken = goodT(UT) &
      UT = [UTId,IDCert,PrivCert,IandACert,AuthCert] &
        IDCert = [[Id,ValidityPeriod,IsValidatedBy],[_,_]] & 
          Id = [Issuer] &
    [Issuer,M] in IssuerKey & M in IsValidatedBy &
    (PrivCert = 
       [PCId,PCValidityPeriod,PCIsValidatedBy,PBaseCertId,PTokenID,_,_] &
       PCId = [PCIssuer] &
       IandACert = 
         [IAId,IAValidityPeriod,IAIsValidatedBy,IBaseCertId,ITokenID,_] &
         IAId = [IAIssuer] &
     [PCIssuer,PCM] in IssuerKey & PCM in PCIsValidatedBy &
     [IAIssuer,IAM] in IssuerKey & IAM in IAIsValidatedBy &
    PBaseCertId = Id &
    IBaseCertId = Id &
    PTokenID = UTId &
    ITokenID = UTId &
    Now in ValidityPeriod &
    Now in PCValidityPeriod &
    Now in IAValidityPeriod
    or
    the(AuthCert,TheAuthCert) & 
      TheAuthCert = [ACId,_,ACIsValidatedBy,BaseCertId,TTokenID,_,_] &
        ACId = [ACIssuer] &
    TTokenID = UTId &
    BaseCertId = Id &
    the(OwnName,ACIssuer) &
    [ACIssuer,ACM] in IssuerKey & ACM in ACIsValidatedBy
   ) &
    tisUnlockDoor(IDStation,RealWorld,RealWorld_,IDStation_)
  or
  tisCompleteFailedAccess(IDStation,RealWorld,RealWorld_,IDStation_).

tisAdminOp_1(M,IDStation,RealWorld,RealWorld_,IDStation_) :-
    IDStation = [_,AdminToken,_,_,_,_,_,_,_,Admin,_,_,_,_] &
      AdminToken = [CurrentAdminToken,_] &
      Admin = [RolePresent,_,_] &

    CurrentAdminToken = goodT(AT) &   %%% (2)
    validToken(AT) & 
      AT = [_,_,_,_,AuthCert] &
      the(AuthCert,AC) & AC = [_,_,_,_,_,Role,_] & 
    TheRolePresent = Role & the(RolePresent,TheRolePresent) & 
    idStationInv04(IDStation,X) &
    tisOverrideDoorLockOp(IDStation,RealWorld,RealWorld_,IDStation_)
  or
  tisShutdownOp(IDStation,RealWorld,RealWorld_,IDStation_)
  or
  tisUpdateConfigDataOp(M,IDStation,RealWorld,RealWorld_,IDStation_)
  or
  tisArchiveLogOp(IDStation,RealWorld,RealWorld_,IDStation_).

tisOp_1(M,IDStation,RealWorld,RealWorld_,IDStation_) :-
  (tisEnrolOp(IDStation,RealWorld,RealWorld_,IDStation_)
   or
   tisUserEntryOp_1(IDStation,RealWorld,RealWorld_,IDStation_)
   or
   tisAdminLogon(IDStation,RealWorld,RealWorld_,IDStation_)
   or
   tisStartAdminOp(IDStation,RealWorld,RealWorld_,IDStation_)
   or
   tisAdminOp_1(M,IDStation,RealWorld,RealWorld_,IDStation_)
   or
   tisAdminLogout(IDStation,RealWorld,RealWorld_,IDStation_)
   or
   RealWorld = [TISControlledRealWorld,_] &
   RealWorld_ = [TISControlledRealWorld_,_] &
   tisIdle(IDStation,TISControlledRealWorld,TISControlledRealWorld_,IDStation_)
  ) & delay(logChange(IDStation,IDStation_),false).

tisOpThenUpdate_1(M,IDStation,RealWorld,RealWorld_,IDStation_) :-
  tisUpdate(IDStation__,RealWorld__,RealWorld_,IDStation_) &
  tisOp_1(M,IDStation,RealWorld,RealWorld__,IDStation__).

property1 :-
  tisOpThenUpdate_1(M,IDStation,RealWorld,RealWorld_,IDStation_) &
    IDStation = 
      [UserToken,AdminToken,Finger,DoorLatchAlarm,_,_,_,_,KeyStore,_,_,_,_,_] &
      UserToken = [CurrentUserToken,_] &
      AdminToken = [CurrentAdminToken,_] &
      DoorLatchAlarm = [CurrentTime,_,CurrentLatch,_,_,_] &
      KeyStore = [IssuerKey,_] &
    RealWorld = [TISControlledRealWorld,TISMonitoredRealWorld] &
      TISControlledRealWorld = [Latch,_,_,_] &
      TISMonitoredRealWorld = [Now,_,_,_,_,_,_] &
    RealWorld_ = [TISControlledRealWorld_,_] &
      TISControlledRealWorld_ = [Latch_,_,_,_] &
  pfun(IssuerKey) &   % state invariant
  Latch = locked & Latch = CurrentLatch & Latch_ = unlocked &
  (CurrentUserToken in {noT, badT}
   or
   CurrentUserToken = goodT(T) &
   (not_validToken(T)
    or
    not_userTokenOKNoCurrencyCheck(KeyStore,UserToken,CurrentTime,Now)
    or
    not_fingerOK(Finger,UserToken)
   )
  ) &
  (CurrentUserToken in {noT, badT}
   or
   CurrentUserToken = goodT(T) &
   (not_tokenWithValidAuth(T)
    or
    not_userTokenWithOKAuthCertNoCurrencyCheck(KeyStore,UserToken,CurrentTime)
   )
  ) &
  (CurrentAdminToken in {noT, badT}
   or
   CurrentAdminToken = goodT(CAT) &
     CAT = [_,_,_,_,AdminAuthCert] &
   (not_validToken(CAT)
    or
    AdminAuthCert = {}
    or
    the(AdminAuthCert,AAAC) & AAAC = [_,_,_,_,_,Role,_] & Role neq guard
   )
  ).

% Property 2: The assumption made in Security Properties, 
% sec. 3.2.2 (p. 10), can't be made in {log} because it 
% requires variable integer intervals in combination with RIS.
% Future versions will support this.

timesRecentTo(TR) :-
  pfun(TR) &
  foreach([T,RT] in TR, integer(T) & T in RT).

property2(TimesRecentTo) :-
  timesRecentTo(TR) &
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
    IDStation = 
      [_,_,_,DoorLatchAlarm,_,_,Config,_,_,_,_,_,_,_] &
      AdminToken = [_,AdminTokenPresence] &
      DoorLatchAlarm = [CurrentTime,_,_,_,_,_] &
      Config = [_,_,_,_,_,EntryPeriod,_,_] &
    RealWorld = [TISControlledRealWorld,_] &
      TISControlledRealWorld = [Latch,_,_,_] &
    RealWorld_ = [TISControlledRealWorld_,_] &
      TISControlledRealWorld_ = [Latch_,_,_,_] &
  Latch = locked & Latch_ = unlocked & 

  AdminTokenPresence = absent &
  Latch = CurrentLatch & 
  (CurrentUserToken in {noT, badT}
   or
   CurrentUserToken = goodT(T) &
     T = [_,_,PrivCert,_,_] & 
     PrivCert = [_,_,_,_,_,Role,Clearance] & Clearance = [Class] &
   (not_validToken(T)
    or
    apply(TR,CurrentTime,RTCT) &
    foreach(RecentTime in RTCT,[C,M],
      C neq Class or RecentTime nin M,
      apply(EntryPeriod,Role,[C,M]))
   )
  ).

property3 :-
  idStationInv01(IDStation) &
  (tisEarlyUpdate(IDStation,RealWorld,RealWorld_,IDStation_) 
   or
   tisUpdate(IDStation,RealWorld,RealWorld_,IDStation_)
  ) &
    IDStation = [_,_,_,DoorLatchAlarm,_,_,_,_,_,_,_,_,_,_] &
      DoorLatchAlarm = [_,_,_,_,_,AlarmTimeout] &
    RealWorld = [_,TISMonitoredRealWorld] &
      TISMonitoredRealWorld = [Now,_,_,_,_,_,_] &
    IDStation_ = [_,_,_,DoorLatchAlarm_,_,_,_,_,_,_,_,_,_,_] &
      DoorLatchAlarm_ = [CurrentTime_,CurrentDoor_,_,_,_,_] &
    RealWorld_ = [TISControlledRealWorld_,_] &
      TISControlledRealWorld_ = [Latch_,Alarm_,_,_] &
  Latch_ = locked &
  CurrentDoor_ = open &
  CurrentTime_ >= AlarmTimeout &
  Alarm_ neq alarming.

%  tisArchiveLogOp doesn't verify Property 4
property4 :-
  delay(logChange(IDStation,IDStation_),false) &
  solve(
   (tisEnrolOp_P4(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisReadUserToken(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisValidateUserToken(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisReadFinger(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisValidateFinger(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisWriteUserToken(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisValidateEntry(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisUnlockDoor(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisCompleteFailedAccess(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisAdminLogon(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisOverrideDoorLockOp(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisShutdownOp(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    tisUpdateConfigDataOp(M,IDStation,RealWorld,RealWorld_,IDStation_)
  %  tisArchiveLogOp doesn't verify Property 4
  %  or
  %  tisArchiveLogOp(IDStation,RealWorld,RealWorld_,IDStation_).
    or
    tisAdminLogout(IDStation,RealWorld,RealWorld_,IDStation_)
    or
    RealWorld = [TISControlledRealWorld,_] &
    RealWorld_ = [TISControlledRealWorld_,_] &
    tisIdle(IDStation,TISControlledRealWorld,TISControlledRealWorld_,IDStation_)
    ) & 
    IDStation = [_,_,_,_,Floppy,_,_,_,_,_,AuditLog,_,_,_] &
      Floppy = [CurrentFloppy,_,_] &
      AuditLog = [AauditLog,AuditAlarm] &
    IDStation_ = [_,_,_,_,Floppy_,_,_,_,_,_,AuditLog_,_,_,_] &
      Floppy_ = [CurrentFloppy_,_,_] &
      AuditLog_ = [AauditLog_,AuditAlarm_] &
    AuditAlarm_ = AuditAlarm & AuditAlarm_ = silent &
    (CurrentFloppy = auditFile(AF) &
     Audit = AF
     or
     CurrentFloppy in {noFloppy, emptyFloppy, badFloppy} &
     Audit = {}
     or
     CurrentFloppy = enrolmentFile(_) &
     Audit = {}
     or
     CurrentFloppy = configFile(_) &
     Audit = {}
    ) &
    (CurrentFloppy_ = auditFile(AF_) &
     Audit_ = AF_
     or
     CurrentFloppy_ in {noFloppy, emptyFloppy, badFloppy} &
     Audit_ = {}
     or
     CurrentFloppy_ = enrolmentFile(_) &
     Audit_ = {}
     or
     CurrentFloppy_ = configFile(_) &
     Audit_ = {}
    ) &
    un(AauditLog,Audit,M) &
    un(AauditLog_,Audit_,M_) &
    nsubset(M,M_)
  ).

property6 :-
  tisOpThenUpdate(M,IDStation,RealWorld,RealWorld_,IDStation_) &
    IDStation = [_,AdminToken,_,_,Floppy,_,Config,_,_,_,_,_,_,_] &
    AdminToken = [_,AdminTokenPresence] &
    IDStation_ = [_,_,_,_,Floppy_,_,Config_,_,_,_,_,_,_,_] &
    AdminTokenPresence = absent &
    (Config neq Config_
     or
     Floppy_ neq Floppy
    ).

checkAllPropConc :-
  prolog_call(get_time(Ti)) &
  prolog_call(concurrent(4,
  [\+setlog(nl & write('Checking Property 1.1...') & prolog_call(flush_output) &
   property1_01),
   \+setlog(nl & write('Checking Property 1.2...') & prolog_call(flush_output) &
   property1_02),
   \+setlog(nl & write('Checking Property 1.3...') & prolog_call(flush_output) &
   property1_03),
   \+setlog(nl & write('Checking Property 1.4...') & prolog_call(flush_output) &
   property1_04),
   \+setlog(nl & write('Checking Property 1.5...') & prolog_call(flush_output) &
   property1_05),
   \+setlog(nl & write('Checking Property 1.6...') & prolog_call(flush_output) &
   property1_06),
   \+setlog(nl & write('Checking Property 1.7...') & prolog_call(flush_output) &
   property1_07),
   \+setlog(nl & write('Checking Property 1.8...') & prolog_call(flush_output) &
   property1_08),
   \+setlog(nl & write('Checking Property 1.9...') & prolog_call(flush_output) &
   property1_09),
   \+setlog(nl & write('Checking Property 1.10...') & prolog_call(flush_output) &
   property1_10),
   \+setlog(nl & write('Checking Property 1.11...') & prolog_call(flush_output) &
   property1_11),
   \+setlog(nl & write('Checking Property 1.12...') & prolog_call(flush_output) &
   property1_12),
   \+setlog(nl & write('Checking Property 1.13...') & prolog_call(flush_output) &
   property1_13),
   \+setlog(nl & write('Checking Property 1.14...') & prolog_call(flush_output) &
   property1_14),
   \+setlog(nl & write('Checking Property 1.15...') & prolog_call(flush_output) &
   property1_15),
   \+setlog(nl & write('Checking Property 1...') & prolog_call(flush_output) &
   property1),
   \+setlog(nl & write('Checking Property 3...') & prolog_call(flush_output) &
   property3)
   ],[])) &
  prolog_call(concurrent(4,
   [\+setlog(nl & write('Checking Property 4...') & prolog_call(flush_output) &
   property4),
   \+setlog(nl & write('Checking Property 6...') & prolog_call(flush_output) &
   property6)
   ],[])) &
   prolog_call(get_time(Te)) & prolog_call(T is Te - Ti) &
   nl & nl & write('All proof obligations discharged in ') & write(T) & 
   write(' seconds') & nl.

checkAllProp :-
  prolog_call(get_time(Ti)) &
  (nl & write('Checking Property 1.1...') & prolog_call(flush_output) &
   property1_01 or
   nl & write('Checking Property 1.2...') & prolog_call(flush_output) &
   property1_02 or
   nl & write('Checking Property 1.3...') & prolog_call(flush_output) &
   property1_03 or
   nl & write('Checking Property 1.4...') & prolog_call(flush_output) &
   property1_04 or
   nl & write('Checking Property 1.5...') & prolog_call(flush_output) &
   property1_05 or
   nl & write('Checking Property 1.6...') & prolog_call(flush_output) &
   property1_06 or
   nl & write('Checking Property 1.7...') & prolog_call(flush_output) &
   property1_07 or
   nl & write('Checking Property 1.8...') & prolog_call(flush_output) &
   property1_08 or
   nl & write('Checking Property 1.9...') & prolog_call(flush_output) &
   property1_09 or
   nl & write('Checking Property 1.10...') & prolog_call(flush_output) &
   property1_10 or
   nl & write('Checking Property 1.11...') & prolog_call(flush_output) &
   property1_11 or
   nl & write('Checking Property 1.12...') & prolog_call(flush_output) &
   property1_12 or
   nl & write('Checking Property 1.13...') & prolog_call(flush_output) &
   property1_13 or
   nl & write('Checking Property 1.14...') & prolog_call(flush_output) &
   property1_14 or
   nl & write('Checking Property 1.15...') & prolog_call(flush_output) &
   property1_15 or
   nl & write('Checking Property 1...') & prolog_call(flush_output) &
   property1 or
   nl & write('Checking Property 3...') & prolog_call(flush_output) &
   property3 or
   nl & write('Checking Property 4...') & prolog_call(flush_output) &
   property4 or
   nl & write('Checking Property 6...') & prolog_call(flush_output) &
   property6 or
   prolog_call(get_time(Te)) & prolog_call(T is Te - Ti) &
   nl & nl & write('All proof obligations discharged in ') & write(T) & 
   write(' seconds') & nl
  ).

userTokenWithOKAuthCertNoCurrencyCheck(KeyStore,UserToken,_CurrentTime) :-
  UserToken = [CurrentUserToken,_] &

  0 =< CurrentTime &   % implicit precondition

  CurrentUserToken = goodT(_) & 

  tokenWithValidAuth(T) &
    goodT(T) = CurrentUserToken & 
      T = [_,_,_,_,AuthCert] &

    the(AuthCert,M2) & M2 = [M3,M1,M4,_,_,_,_] &
    authCertOK(KeyStore,[M3,M1,M4]).

not_userTokenWithOKAuthCertNoCurrencyCheck(KeyStore,UserToken,_CurrentTime) :-
   UserToken = [CurrentUserToken,_] &

  (CurrentUserToken in {noT, badT}
   or
   CurrentUserToken = goodT(T) & 
     T = [_,_,_,_,AuthCert] &
   (not_tokenWithValidAuth(T)
    or
    AuthCert = {}
    or
    the(AuthCert,M3) & M3 = [Id,ValidityPeriod,IsValidatedBy,_,_,_,_] &
      not_authCertOK(KeyStore,[Id,ValidityPeriod,IsValidatedBy])
   )
  ).

userTokenOKNoCurrencyCheck(KeyStore,UserToken,CurrentTime,Now) :-
  UserToken = [CurrentUserToken,_] &

  0 =< CurrentTime &   % implicit precondition

  CurrentUserToken = goodT(_) & 

  currentToken(Token,Now) & 
    Token = [_,IDCert,PrivCert,IandACert,_] &
      IDCert = [[Id,ValidityPeriod,IsValidatedBy],[_,_]] & 
      PrivCert = [PCId,PCValidityPeriod,PCIsValidatedBy,_,_,_,_] &
      IandACert = [IAId,IAValidityPeriod,IAIsValidatedBy,_,_,_] &

    goodT(Token) = CurrentUserToken & 

    certOK(KeyStore,[Id,ValidityPeriod,IsValidatedBy]) &

    certOK(KeyStore,[PCId,PCValidityPeriod,PCIsValidatedBy]) &

    certOK(KeyStore,[IAId,IAValidityPeriod,IAIsValidatedBy]).

not_userTokenOKNoCurrencyCheck(KeyStore,UserToken,CurrentTime,Now) :-
  UserToken = [CurrentUserToken,_] &

  (CurrentUserToken in {noT, badT}
   or
   CurrentUserToken = goodT(Token) & 
     Token = [_,IDCert,PrivCert,IandACert,_] &
       IDCert = [[Id,ValidityPeriod,IsValidatedBy],[_,_]] &
       PrivCert = [PCId,PCValidityPeriod,PCIsValidatedBy,_,_,_,_] &
       IandACert = [ICId,ICValidityPeriod,ICIsValidatedBy,_,_,_] &
   (not_currentToken(Token,Now)
    or
    not_certOK(KeyStore,[Id,ValidityPeriod,IsValidatedBy])
    or
    not_certOK(KeyStore,[PCId,PCValidityPeriod,PCIsValidatedBy])
    or
    not_certOK(KeyStore,[ICId,ICValidityPeriod,ICIsValidatedBy])
   )
  ).


